## adios 1.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)

#move here bedore project, otherwise SET(CMAKE_INSTALL_PREFIX < install_path>) will not work
if(NOT CMAKE_INSTALL_PREFIX)
  # if CMAKE_INSTALL_PREFIX isn't set, try to get it from the INSTALL_PREFIX environment variable
  set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
endif()

project(ADIOS_PROJECT)

SET_PROPERTY(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)

#set(LANGUAGE "" CACHE FILEPATH "")  #C/CXX/Fortran

#enable_language(${LANGUAGE})
#message(STATUS "CMAKE_${LANGUAGE}_COMPILER_WORKS = ${CMAKE_${LANGUAGE}_COMPILER_WORKS}")

include_directories(${PROJECT_SOURCE_DIR})
link_directories(${PROJECT_BINARY_DIR})
#message("${PROJECT_SOURCE_DIR}")

#set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

#if(NOT CMAKE_INSTALL_PREFIX)
#  set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
#endif()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix})
set(bindir ${exec_prefix}/bin)
#set(datadir ${prefix}/share)
set(libdir ${exec_prefix}/lib)
set(includedir ${prefix}/include)
set(sysconfdir ${prefix}/etc)

if(DEFINED ENV{MACRODEFFLAG})
  set(MACRODEFFLAG $ENV{MACRODEFFLAG})
else()
  set(MACRODEFFLAG "-D")
endif()
message(STATUS "MACRODEFFLAG = ${MACRODEFFLAG}")

set(LIBS "")
set(CPPFLAGS "$ENV{CPPFLAGS}")
set(CFLAGS "$ENV{CFLAGS}")
set(EXTRA_CFLAGS "$ENV{EXTRA_CFLAGS}")
set(EXTRA_LIBS "$ENV{EXTRA_LIBS}")
######## file moved from initial_cache.cmake to indicate external library is used(ON) or not (OFF)######
if(DEFINED ENV{BUILD_WRITE})
  if("$ENV{BUILD_WRITE}" STREQUAL "") 
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE $ENV{BUILD_WRITE})
  endif()
  if(BUILD_WRITE)
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_WRITE ON CACHE BOOL "")
endif()

if(DEFINED ENV{BUILD_FORTRAN})
  if("$ENV{BUILD_FORTRAN}" STREQUAL "")
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN $ENV{BUILD_FORTRAN})
  endif()
  if(BUILD_FORTRAN)
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_FORTRAN ON CACHE BOOL "")
endif()

if(DEFINED ENV{adios_timers})
  if("$ENV{adios_timers}" STREQUAL "")
    set(ADIOS_TIMERS 0)
  elseif("$ENV{adios_timers}" STREQUAL "ON")
    set(ADIOS_TIMERS 1)
  elseif("$ENV{adios_timers}" STREQUAL "on")
    set(ADIOS_TIMERS 1)
  elseif("$ENV{adios_timers}" STREQUAL "OFF")
    set(ADIOS_TIMERS 0)
  elseif("$ENV{adios_timers}" STREQUAL "off")
    set(ADIOS_TIMERS 0)
  else()
    set(ADIOS_TIMERS 0)
  endif()
  if(ADIOS_TIMERS)
    set(SKEL_HAVE_ADIOS_TIMING True)
  else()
    set(SKEL_HAVE_ADIOS_TIMING False)
  endif()
else()
  # default is on if not specified
  set(ADIOS_TIMERS 1)
  set(SKEL_HAVE_ADIOS_TIMING True)
endif()

if(DEFINED ENV{adios_timer_events})
  if("$ENV{adios_timer_events}" STREQUAL "")
    set(ADIOS_TIMER_EVENTS 0)
  elseif("$ENV{adios_timer_events}" STREQUAL "ON")
    set(ADIOS_TIMER_EVENTS 1)
  elseif("$ENV{adios_timer_events}" STREQUAL "on")
    set(ADIOS_TIMER_EVENTS 1)
  elseif("$ENV{adios_timer_events}" STREQUAL "OFF")
    set(ADIOS_TIMER_EVENTS 0)
  elseif("$ENV{adios_timer_events}" STREQUAL "off")
    set(ADIOS_TIMER_EVENTS 0)
  else()
    set(ADIOS_TIMER_EVENTS 0)
  endif()
else()
  #default is off if not specified
  set(ADIOS_TIMER_EVENTS 0)
endif()

if(DEFINED ENV{bgq})
  if("$ENV{bgq}" STREQUAL "")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "ON")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "on")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "OFF")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "Off")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  else()
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  endif()
else()
  set(HAVE_BGQ 0)
  set(BGQ OFF CACHE BOOL "")
endif()

if(DEFINED ENV{research_transports})
  if("$ENV{research_transports}" STREQUAL "")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "OFF")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "off")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "on")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  elseif("$ENV{research_transports}" STREQUAL "ON")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  else()
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  endif()
else()
  set(RESEARCH_TRANSPORTS 0)
  message("research_transports is NOT enabled")
endif()

set(MXML_DIR $ENV{MXML_DIR}  CACHE FILEPATH "path to mxml dir")

set(DATATAP OFF CACHE BOOL "")

set(NSSI OFF CACHE BOOL "")

if(DEFINED ENV{SEQ_NC_DIR})
  if("$ENV{SEQ_NC_DIR}" STREQUAL "")
    set(NETCDF OFF CACHE BOOL "")
  else()
    set(NETCDF ON CACHE BOOL "")
    set(NETCDF_DIR "$ENV{SEQ_NC_DIR}" CACHE FILEPATH "path to suquential NETCDF dir")
  endif()
else()
  set(NETCDF OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PAR_NC_DIR})
  if("$ENV{PAR_NC_DIR}" STREQUAL "")
    set(NC4PAR OFF CACHE BOOL "")
  else()
    set(NC4PAR ON CACHE BOOL "")
    set(NC4PAR_DIR "$ENV{PAR_NC_DIR}" CACHE FILEPATH "path to parallel NETCDFdir")
  endif()
else()
  set(NC4PAR OFF CACHE BOOL "")
endif()

#if(DEFINED ENV{PAR_NC_DIR} AND DEFINED ENV{PAR_NC_CLIB})
#  set(NC4PAR ON CACHE BOOL "")
#  set(NC4PAR_DIR $ENV{PAR_NC_DIR} CACHE FILEPATH "")
#  set(NC4PAR_CPPFLAGS "-I${NC4PAR_DIR}/include")
#  set(NC4PAR_LIBS $ENV{PAR_NC_CLIB} CACHE STRING "parallel netcdf")
#else()
#  set(NC4PAR OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{SEQ_NC_DIR} AND DEFINED ENV{SEQ_NC_CLIB})
#  set(NETCDF ON CACHE BOOL "")
#  set(NETCDF_DIR $ENV{SEQ_NC_DIR} CACHE FILEPATH "")
#  set(NETCDF_CPPFLAGS "-I${NETCDF_DIR}/include")
#  set(NETCDF_LIBS $ENV{SEQ_NC_CLIB} CACHE STRING "")
#else()
#  set(NETCDF OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{PAR_HDF5_DIR} AND DEFINED ENV{PAR_HDF5_CLIB})
#  set(PHDF5 ON CACHE BOOL "")
#  set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
#  set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#  set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
#else()
#  set(PHDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{PAR_HDF5_DIR})
  if("$ENV{PAR_HDF5_DIR}" STREQUAL "")
    set(PHDF5 OFF CACHE BOOL "")
  else()
    set(PHDF5 ON CACHE BOOL "")
    set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
    set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#   set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
  endif()
else()
  set(PHDF5 OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PORTALS_DIR})
  if("$ENV{PORTALS_DIR}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS_DIR}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
elseif(DEFINED ENV{PORTALS})
  if("$ENV{PORTALS}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
else()
  set(PORTALS OFF CACHE BOOL "")
endif()

if(DEFINED ENV{DATASPACES_INCDIR})
  if("${DATASPACES_INCDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "")
  else()
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "")
endif()
if(DEFINED ENV{DATASPACES_LIBDIR})
  if("${DATASPACES_LIBDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "" FORCE)
  else()
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED DATASPACES_INCDIR)
  if(DEFINED DATASPACES_LIBDIR)
    set(DATASPACES ON CACHE BOOL "" FORCE)
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE STRING "" FORCE)
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${DATASPACES}" STREQUAL "OFF")
  if(DEFINED ENV{DATASPACES_DIR})
    if(NOT "$ENV{DATASPACES_DIR}" STREQUAL "")
      set(DATASPACES ON CACHE BOOL "" FORCE)
      set(DATASPACES_DIR $ENV{DATASPACES_DIR} CACHE FILEPATH "path to dataspaces dir")
    endif()
#  set(DATASPACES_LIBS "-L$ENV{DATASPACES_DIR}/libs -ldspaces -ldscommon
#  -ldar" CACHE STRING "dataspace libs")
  else()
    if(NOT "$ENV{DATASPACES}" STREQUAL "")
      set(DATASPACES_DIR $ENV{DATASPACES} CACHE FILEPATH "path to dataspaces dir")
      set(DATASPACES ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

if(DEFINED ENV{CRAY_PMI_DIR})
  set(CRAY_PMI_DIR $ENV{CRAY_PMI_DIR})
  if(CRAY_PMI_DIR)
    set(CRAY_PMI ON CACHE BOOL "")
    set(CRAY_PMI_LIBS_PATH "${CRAY_PMI_DIR}/lib64" CACHE STRING "")
    set(CRAY_PMI_CPPFLAGS "-I${CRAY_PMI_DIR}/include" CACHE STRING "")
  else()
    set(CRAY_PMI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_PMI OFF CACHE BOOL "")
endif()

if(DEFINED ENV{CRAY_UGNI_DIR})
  set(CRAY_UGNI_DIR $ENV{CRAY_UGNI_DIR})
  if(CRAY_UGNI_DIR)
    set(CRAY_UGNI ON CACHE BOOL "")
    set(CRAY_UGNI_LIBS_PATH "${CRAY_UGNI_DIR}/lib64" CACHE STRING "")
    set(CRAY_UGNI_CPPFLAGS "-I${CRAY_UGNI_DIR}/include")
  else()
    set(CRAY_UGNI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_UGNI OFF CACHE BOOL "")
endif()

if(DATASPACES)
  set(DIMES ON CACHE BOOL "")
else()
  set(DIMES OFF CACHE BOOL "")
endif()

if(DEFINED ENV{FLEXPATH_INCDIR})
  if("${FLEXPATH_INCDIR}" STREQUAL "")
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "")
endif()
if(DEFINED ENV{FLEXPATH_LIBDIR})
  if("${FLEXPATH_LIBDIR}" STREQUAL "" FORCE)
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED FLEXPATH_INCDIR)
  if(DEFINED FLEXPATH_LIBDIR)
    set(FLEXPATH ON CACHE BOOL "" FORCE)
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE STRING "" FORCE)
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${FLEXPATH}" STREQUAL "OFF")
  if(DEFINED ENV{FLEXPATH_DIR})
    if(NOT "$ENV{FLEXPATH_DIR}" STREQUAL "")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
      set(FLEXPATH_DIR $ENV{FLEXPATH_DIR} CACHE FILEPATH "path to flexpath dir")
    endif()
  else()
    if(NOT "$ENV{FLEXPATH}" STREQUAL "")
      set(FLEXPATH_DIR $ENV{FLEXPATH} CACHE FILEPATH "path to flexpath dir")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

if(DEFINED ENV{FASTBIT_DIR})
  if(NOT "$ENV{FASTBIT_DIR}" STREQUAL "")
    set(FASTBIT ON CACHE BOOL "")
    set(FASTBIT_DIR "$ENV{FASTBIT_DIR}" CACHE FILEPATH "path to fastbit dir")
  else()
    set(FASTBIT OFF CACHE BOOL "")
  endif()
else()
  if(NOT "$ENV{FASTBIT}" STREQUAL "")
    set(FASTBIT_DIR $ENV{FASTBIT} CACHE FILEPATH "path to fastbit dir")
    set(FASTBIT ON CACHE BOOL "" FORCE)
  endif()
endif()

#if(DEFINED ENV{SEQ_HDF5_DIR} AND DEFINED ENV{SEQ_HDF5_CLIB})
#  set(HDF5 ON CACHE BOOL "")
#  set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
#  set(HDF5_FLAGS "-I${HDF5_DIR}/include")
#  set(HDF5_LIBS "$ENV{SEQ_HDF5_CLIB}" CACHE FILEPATH "sequential hdf5")
#else()
#  set(HDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{SEQ_HDF5_DIR})
  if("$ENV{SEQ_HDF5_DIR}" STREQUAL "")
    set(HDF5 OFF CACHE BOOL "")
  else()
    set(HDF5 ON CACHE BOOL "" FORCE)
    set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
    set(HDF5_FLAGS "-I${HDF5_DIR}/include")

=== src/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/src/core ${PROJECT_SOURCE_DIR}/src/core/transforms)
include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/src)

if(HAVE_NSSI)
  add_executable(nssi-staging-server nssi/nssi_staging_server.cpp nssi/aggregation.cpp)
  set_target_properties(nssi-staging-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-staging-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})

  add_executable(nssi-coupling-server nssi/nssi_coupling_server.cpp)
  set_target_properties(nssi-coupling-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-coupling-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})
endif(HAVE_NSSI)

set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

set(libadiosread_a_CPPFLAGS "")
set(libadiosreadf_a_CPPFLAGS "")
set(libadiosread_nompi_a_CPPFLAGS "")
set(libadiosreadf_nompi_a_CPPFLAGS "")

set(libadiosread_a_CFLAGS "")
set(libadiosreadf_a_CFLAGS "")
set(libadiosread_nompi_a_CFLAGS "")
set(libadiosreadf_nompi_a_CFLAGS "")

## Transform plugin source files
set(transforms_write_method_SOURCES "")
set(transforms_read_method_SOURCES "")

#include (transforms/Makefile.plugins.cmake)

##
## Core transform framework source files
##
set (transforms_common_HDRS core/adios_copyspec.h 
                         core/adios_subvolume.h 
                         core/adios_selection_util.h 
                         core/transforms/adios_transforms_common.h 
                         core/transforms/adios_transforms_hooks.h 
                         core/transforms/adios_transforms_util.h 
                         core/adios_subvolume.h)

set (transforms_read_HDRS core/transforms/adios_transforms_read.h 
                       core/transforms/adios_transforms_hooks_read.h 
                       core/transforms/adios_transforms_reqgroup.h 
                       core/transforms/adios_transforms_datablock.h
                       core/transforms/adios_transforms_transinfo.h
                       core/transforms/adios_patchdata.h)

set (transforms_write_HDRS  core/transforms/adios_transforms_write.h 
                        core/transforms/adios_transforms_hooks_write.h 
                        core/transforms/adios_transforms_specparse.h)

set (transforms_common_SOURCES  ${transforms_common_HDRS} 
                            core/transforms/adios_transforms_common.c 
                            core/transforms/adios_transforms_hooks.c 
                            core/adios_copyspec.c 
                            core/adios_subvolume.c 
                            core/transforms/plugindetect/detect_plugin_infos.h 
                            core/transforms/plugindetect/detect_plugin_types.h 
                            core/transforms/plugindetect/plugin_info_types.h)

set (transforms_read_SOURCES ${transforms_read_HDRS} 
                          core/transforms/adios_transforms_read.c 
                          core/transforms/adios_transforms_hooks_read.c 
                          core/transforms/adios_transforms_reqgroup.c 
                          core/transforms/adios_transforms_datablock.c 
                          core/transforms/adios_patchdata.c 
                          transforms/adios_transform_alacrity_read.c
                          transforms/adios_transform_isobar_read.c
                          transforms/adios_transform_aplod_read.c
                          transforms/adios_transform_szip_read.c 
                          transforms/adios_transform_bzip2_read.c
                          transforms/adios_transform_identity_read.c
                          transforms/adios_transform_zlib_read.c
                          core/adios_selection_util.c 
                          core/transforms/plugindetect/detect_plugin_read_hook_decls.h
                          core/transforms/plugindetect/detect_plugin_read_hook_reg.h
                          core/adios_read_ext.c
                          ${transforms_read_method_SOURCES})

set (transforms_write_SOURCES ${transforms_write_HDRS} 
                           core/transforms/adios_transforms_write.c 
                           core/transforms/adios_transforms_hooks_write.c 
                           core/transforms/adios_transforms_util.c 
                           core/transforms/adios_transforms_specparse.c 
                           transforms/adios_transform_alacrity_write.c
                           transforms/adios_transform_aplod_write.c
                           transforms/adios_transform_bzip2_write.c
                           transforms/adios_transform_identity_write.c
                           transforms/adios_transform_isobar_write.c
                           transforms/adios_transform_szip_write.c
                           transforms/adios_transform_zlib_write.c
                           ${transforms_write_method_SOURCES})

#######Query source files
set(query_common_HDRS query/common_query.h
                      query/adios_query_hooks.h
                      query/query_utils.h)

set(query_common_SOURCES ${query_common_HDRS}
                         query/common_query.c
                         query/adios_query_hooks.c
                         query/query_utils.c)

# Include source files that are specific to each query plugin
set(query_method_HDRS "")
set(query_method_SOURCES "")
include(query/Makefile.plugins.cmake)

set(query_method_SOURCES ${query_method_SOURCES} ${query_method_HDRS})

set(query_SOURCES ${query_common_SOURCES} ${query_method_SOURCES})

set(query_C_SOURCES ${query_SOURCES} query/adios_query.c)
set(query_F_SOURCES ${query_SOURCES} query/adiosf_query.c)

#start adios.a and adios_nompi.a
if(BUILD_WRITE)
    set(libadios_a_SOURCES core/adios.c 
                     core/common_adios.c
                     core/adios_internals.c
                     core/adios_internals_mxml.c 
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/adios_infocache.c
                     core/adios_read_ext.c
                     core/globals.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/qhashtbl.c 
                     ${transforms_common_SOURCES} 
                     ${transforms_read_SOURCES} 
                     ${transforms_write_SOURCES} 
                     ${query_C_SOURCES}
                     core/util.c 
                     core/qhashtbl.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c
                     write/adios_mpi.c
                     write/adios_mpi_lustre.c
                     write/adios_mpi_amr.c
                     write/adios_posix.c
                     write/adios_posix1.c
                     write/adios_var_merge.c)

    if(HAVE_BGQ)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_mpi_bgq.c)
    endif()

    set(libadios_nompi_a_SOURCES core/adios.c 
                     core/common_adios.c 
                     core/adios_internals.c 
                     core/adios_internals_mxml.c 
                     ${transforms_common_SOURCES} 
                     ${transforms_read_SOURCES} 
                     ${transforms_write_SOURCES} 
                     ${query_C_SOURCES}
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/adios_infocache.c
                     core/adios_read_ext.c
                     core/globals.c 
                     core/mpidummy.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/util.c 
                     core/qhashtbl.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c 
                     write/adios_posix.c 
                     write/adios_posix1.c)

#start adiosf.a and adiosf_v1.a
    if(BUILD_FORTRAN)
        set(FortranLibSources core/adiosf.c 
                       core/common_adios.c 
                       core/adios_internals.c 
                       core/adios_internals_mxml.c
                       ${transforms_common_SOURCES} 
                       ${transforms_read_SOURCES} 
                       ${transforms_write_SOURCES} 
                       ${query_F_SOURCES}
                       core/buffer.c 
                       core/adios_bp_v1.c  
                       core/adios_endianness.c
                       core/futils.c 
                       core/adios_error.c 
                       core/bp_utils.c                
                       core/common_read.c 
                       core/adios_infocache.c
                       core/adios_read_ext.c
                       core/globals.c 
                       core/adios_timing.c 
                       core/adios_read_hooks.c 
                       core/adios_transport_hooks.c 
                       core/adios_socket.c 
                       core/adios_logger.c 
                       core/util.c 
                       core/qhashtbl.c 
                       read/read_bp.c 
                       read/read_bp_staged.c 
                       read/read_bp_staged1.c 
                       write/adios_posix.c 
                       write/adios_posix1.c)

        set(FortranLibMPISources write/adios_mpi.c
                         write/adios_mpi_lustre.c
                         write/adios_mpi_amr.c
                         write/adios_var_merge.c)
        if(HAVE_BGQ)
            set(FortranLibMPISources ${FortranLibMPISources} write/adios_mpi_bgq.c)
        endif(HAVE_BGQ)
        set(FortranLibSEQSources core/mpidummy.c)
    endif(BUILD_FORTRAN)

    set(libadios_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
    set(libadios_a_CFLAGS "${ADIOSLIB_CFLAGS}")
    set(libadios_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}") 
    set(libadios_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")
    set(libadiosf_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
    set(libadiosf_a_CFLAGS "${ADIOSLIB_CFLAGS}")
    set(libadiosf_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}")
    set(libadiosf_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")

    if(HAVE_DATASPACES)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
        set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
        if(BUILD_FORTRAN)

=== utils/CMakeLists.txt ===
add_subdirectory(gpp)
add_subdirectory(bpdump)
add_subdirectory(bp2ascii)
add_subdirectory(bpsplit)
add_subdirectory(bpls)
add_subdirectory(bpdiff)
add_subdirectory(bpmeta)
add_subdirectory(bprecover)
add_subdirectory(list_methods)

if(BUILD_WRITE)
  add_subdirectory(adios_lint)
  add_subdirectory(bp2bp)
endif(BUILD_WRITE)

if(HAVE_HDF5)
  add_subdirectory(bp2h5)
endif(HAVE_HDF5)

if(HAVE_NETCDF)
  add_subdirectory(bp2ncd)
endif(HAVE_NETCDF)

if(HAVE_FASTBIT)
  add_subdirectory(fastbit)
endif()

add_subdirectory(skel)
add_subdirectory(skeldump)

#find_library(ADIOS_INTERNAL_NOMPI_LIB adios_internal_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios_internal_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOSREAD_NOMPI_LIB adiosread_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adiosread_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOS_LIB adios ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios.a in ${PROJECT_SOURCE_DIR}/utils makefile")
#endif(${ADIOS_LIB}-NOTFOUND)

=== examples/C/CMakeLists.txt ===
add_subdirectory(scalars)
add_subdirectory(arrays)
add_subdirectory(attributes)
add_subdirectory(manual)
add_subdirectory(global-array)
add_subdirectory(global-array-time)
add_subdirectory(read_all)
add_subdirectory(stat)
add_subdirectory(schema)
add_subdirectory(flexpath_arrays)
add_subdirectory(transforms)
add_subdirectory(query)
add_subdirectory(icee_arrays)
#SUBDIRS=scalars arrays attributes manual global-array global-array-time read_all stat schema

=== tests/C/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/C)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/src)
link_directories(${MXML_INCLUDE_DIR}/../lib)

add_executable(adios_test_c adios_test_c.c)
target_link_libraries(adios_test_c adios ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES}) 
set(adios_test_c_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
set(adios_test_c_CFLAGS "${ADIOSLIB_CFLAGS}")
set_target_properties(adios_test_c PROPERTIES COMPILE_FLAGS "${adios_test_c_CFLAGS} ${adios_test_c_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")
if(MPI_LINK_FLAGS)
   set_target_properties(adios_test_c PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

file(COPY config_c.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/C)

add_subdirectory(flexpath_tests)
add_subdirectory(fgr_tests)
add_subdirectory(query)

=== tests/genarray/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src  ${PROJECT_BINARY_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/tests/genarray)
include_directories(${PROJECT_BINARY_DIR}/tests/genarray)
link_directories(${PROJECT_BINARY_DIR}/tests/genarray)

add_executable(genarray genarray.F90 gwrite_genarray.fh)
target_link_libraries(genarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(genarray2D genarray2D.F90)
target_link_libraries(genarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray copyarray.F90 gread_genarray.fh)
target_link_libraries(copyarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray2D copyarray2D.F90)
target_link_libraries(copyarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_custom_command(
	OUTPUT gwrite_genarray.fh
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

add_custom_command(
        OUTPUT gread_genarray.fh 
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

file(COPY genarray.xml genarray3d.xml job.ewok job2D.ewok DESTINATION ${PROJECT_BINARY_DIR}/tests/genarray)

=== tests/suite/CMakeLists.txt ===
add_subdirectory(programs)

file(COPY HOWTO-Add-new-test HOWTO-Run cleanup.sh test.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)

if(EXISTS ${PROJECT_BINARY_DIR}/tests/suite/reference)
  file(COPY reference/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/reference)
else()
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/suite/reference)
  file(COPY reference/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/reference)
endif()

if(EXISTS ${PROJECT_BINARY_DIR}/tests/suite/tests)
  file(COPY tests/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/tests)
else()
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/suite/tests)
  file(COPY tests/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/tests)
endif()

=== utils/adios_lint/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_SOURCE_DIR}/utils/adios_lint)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/utils/adios_lint)

add_executable(adios_lint adios_lint.c)
target_link_libraries(adios_lint adios_internal_nompi ${ADIOSLIB_INT_LDADD})
set_target_properties(adios_lint PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_INT_CPPFLAGS} ${ADIOSLIB_INT_CFLAGS}")

#install(FILES config.xml DESTINATION ${PROJECT_BINARY_DIR}/utils/adios_lint)
install(PROGRAMS ${CMAKE_BINARY_DIR}/utils/adios_lint/adios_lint DESTINATION ${bindir})

=== utils/bp2ascii/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/utils/bp2ascii)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/utils/bp2ascii)

add_executable(bp2ascii bp2ascii.c)
target_link_libraries(bp2ascii adios_internal_nompi ${ADIOSLIB_INT_LDADD})
set_target_properties(bp2ascii PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_INT_CPPFLAGS} ${ADIOSLIB_INT_CFLAGS}")

if(USE_PARALLEL_COMPILER)
endif(USE_PARALLEL_COMPILER)

=== utils/bpls/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/utils/bpls)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/utils/bpls)

add_executable(bpls bpls.c)
target_link_libraries(bpls adiosread_nompi ${ADIOSREADLIB_SEQ_LDADD})
set_target_properties(bpls PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSREADLIB_SEQ_CPPFLAGS} ${ADIOSREADLIB_SEQ_CFLAGS}")

#install(FILES bpls.h DESTINATION ${PROJECT_BINARY_DIR}/utils/bpls)
install(PROGRAMS ${CMAKE_BINARY_DIR}/utils/bpls/bpls DESTINATION ${bindir})

=== utils/bpmeta/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_SOURCE_DIR}/src/core/transforms)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/src)

add_executable(bpmeta bpmeta.c)
target_link_libraries(bpmeta adios_internal_nompi ${ADIOSLIB_INT_LDADD})
set_target_properties(bpmeta PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_INT_CPPFLAGS} ${ADIOSLIB_INT_CFLAGS}")

install(PROGRAMS ${CMAKE_BINARY_DIR}/utils/bpmeta/bpmeta DESTINATION ${bindir})

=== utils/gpp/CMakeLists.txt ===
install(PROGRAMS gpp.py ad_config.py type_mapper.py DESTINATION ${bindir})

=== debian/changelog ===
adios (1.9.0-7build2) xenial; urgency=medium

  * No change-rebuild for openmpi on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 15 Feb 2016 14:57:44 +0100

adios (1.9.0-7build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 13:01:19 +0000

adios (1.9.0-7) unstable; urgency=medium

  * Fix for openmpi1.10 transition. Closes: #813724.
  * Move to Standards-Version: 3.9.7
  * Add lintian overrides for false-alerts on tmpl scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Feb 2016 22:11:07 +0000

adios (1.9.0-6) unstable; urgency=medium

  * Don't include '-lcr' on x32, 68k either.
  * Use mpif90 instead of mpif77 for MPIFC. (Fix FTBFS on sparc)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 01 Jan 2016 22:46:11 +0000

adios (1.9.0-5) unstable; urgency=medium

  * Fix typo in build rules for s390x.
  * Don't include '-lcr' for MPI builds on hppa

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Nov 2015 18:27:29 +0000

adios (1.9.0-4) unstable; urgency=medium

  * Fix MPI_LIBS for s390x build

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Nov 2015 06:41:15 +0000

adios (1.9.0-3) unstable; urgency=medium

  * Remove mpi-workaround.patch, breaks build on non-mpich archs

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 29 Oct 2015 17:02:01 +0000

adios (1.9.0-2) unstable; urgency=medium

  * Build against all mpi versions again.
  * Link adios_mpi.so python packages against mpi libs 
  * delete old binaries from examples

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 29 Oct 2015 01:32:35 +0000

adios (1.9.0-1) experimental; urgency=medium

  * New upstream release
  * Changes needed for python3 - adapt pyx scripts
  * Temporarily only build for mpich as bug in openmpi 
  * Re-enable tests on bigendian systems for checking
  * Add patch to fix version number.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Oct 2015 11:52:01 +0000

=== debian/control ===
Source: adios
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), 
  libnetcdf-dev, 
  gfortran, libmxml-dev, 
  mpi-default-dev, pkg-config,
  autotools-dev, cmake, libbz2-dev, zlib1g-dev, dh-autoreconf,
  libibverbs-dev [ !hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  python-dev, python-numpy, python-mpi4py, cython, dh-python,
  python3-all-dev, python3-numpy, python3-mpi4py, cython3,
  libglib2.0-dev, libhdf5-serial-dev, libhdf5-mpi-dev
Build-Conflicts: libadios-dev, libadios-bin
Standards-Version: 3.9.7
Homepage: http://www.olcf.ornl.gov/center-projects/adios/
Vcs-git: git://anonscm.debian.org/debian-science/packages/adios.git
X-Python-Version: 2.7
X-Python3-Version: 3.3+

Package: libadios-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Recommends: libadios-bin
Description: ADIOS Adaptable IO system for simulations
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.


Package: libadios-bin
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Architecture: any
Multi-Arch: foreign
Recommends: libadios-dev
Description: ADIOS Adaptable IO system for simulations - binaries
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .
 This package provides tools for use with ADIOS.

Package: python-adios
Depends: ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}, python3-adios
Section: python
Architecture: any
Multi-Arch: same
Breaks: libadios-bin ( << 1.8.0-2), libadios-dev ( << 1.8.0-2)
Replaces: libadios-bin ( << 1.8.0-2), libadios-dev ( << 1.8.0-2)
Provides: ${python:Provides}
Description: Python interface to the ADIOS IO system
 This is a Python2 interface to ADIOS.
 .
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .

Package: python3-adios
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Section: python
Architecture: any
Multi-Arch: same
Provides: ${python:Provides}
Breaks: libadios-bin ( << 1.8.0-2), libadios-dev ( << 1.8.0-2), python-adios ( << 1.8.0-2)
Replaces: libadios-bin ( << 1.8.0-2), libadios-dev ( << 1.8.0-2)
Description: Python3 interface to the ADIOS IO system
 This is a Python3 interface to ADIOS.
 .
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

ARCH:=$(shell dpkg --print-architecture)
WITH_IBVERBS:= --with-ibverbs=/usr
DO_TEST:= true

include /usr/share/mpi-default-dev/debian_defaults
MPI=$(ARCH_DEFAULT_MPI_IMPL)

# TODO: This should come from `pkg-config mpi --libs` ...
ifeq ($(MPI), mpich)
MPI_LIBS:= -Wl,-z,relro -lmpich -lopa -lmpl -lrt -lcr -lpthread
ifeq ($(ARCH),hppa)
MPI_LIBS:= -Wl,-z,relro  -lmpich -lopa -lmpl  -lrt -lpthread
endif
ifeq ($(ARCH), m68k)
MPI_LIBS:= -Wl,-z,relro -lmpich -lopa -lmpl -lrt -lpthread
endif
ifeq ($(ARCH), x32)
MPI_LIBS:= -Wl,-z,relro -lmpich -lopa -lmpl -lrt -lpthread
endif
endif

ifeq ($(MPI), openmpi)
MPI_LIBS:= $(pkg-config mpi-fort --libs)
endif
ifeq ($(ARCH),s390x)
MPI_LIBS:= -Wl,-z,relro  -lmpich -lopa -lmpl  -lrt -lpthread
endif
ifeq ($(ARCH),hurd-i386)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-amd64)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-i386)
  WITH_IBVERBS:=
endif

# TODO: also mpich2 for x32 ...
# DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
BINDIR:=$(DESTDIR)/usr/bin
PY2VERS:=python2.7
PY3VERS:= $(shell py3versions -s)
CFLAGS:=$(shell  dpkg-buildflags --get CFLAGS )

TOP:=$(shell pwd)
export PATH:=$(TOP):$(PATH)

# magic debhelper rule
%:
	dh $@ --with autoreconf,autotools_dev,python2,python3

override_dh_auto_clean:
	dh_clean
	find . -name '*.pyc' -delete
	find . -name '*.o' -delete
	find . -name '*.a' -delete
	find . -name '*.mod' -delete
	rm -fr wrappers/numpy/build wrappers/java/build debian/tmpp
	# Remove dodgy symlinks
	find . -type l -delete
	rm -f ./examples/staging/stage_write/writer_adios config.log 
	rm -f libtool config.h  config.status adios_config.flags  adios_config
	rm -f adios.pc stamp-h1

override_dh_auto_configure:
	dh_auto_configure --  $(WITH_LUSTRE) $(WITH_IBVERBS) --enable-shared \
		--with-hdf5-incdir=/usr/include/hdf5/serial \
		--with-hdf5-libdir=$(LIBDIR)/hdf5/serial \
		--with-phdf5-incdir=/usr/include/hdf5/$(MPI) \
		--with-phdf5-libdir=$(LIBDIR)/hdf5/$(MPI) \
		--with-bzip2=/usr  --with-zlib=/usr --with-glib=/usr \
		--prefix=/usr MPICC=mpicc.$(MPI) MPIFC=mpif90.$(MPI) CFLAGS='$(CFLAGS) -I$(LIBDIR)/glib-2.0/include' \
		LIBS=' $(MPI_LIBS) -lpthread' 

override_dh_auto_build:
	# First do a build shared, with -fPIC, for the python lib.
	$(MAKE) -C src CFLAGS='$(CFLAGS) -fPIC' VERBOSE=1 install DESTDIR=$(DESTDIR)
	# Need to hack the libs into the right place, to match adios_configs view
	# as this is then used by setup.py
	mv debian/tmp/usr/lib/*/*.a debian/tmp/usr/lib
	# Now build Python wrapper. Uses adios_config and the debian/tmp install.
	chmod +x adios_config
	$(MAKE) -C wrappers/numpy python CYTHON=y CYTHON3=y MPI=y
	( cd wrappers/numpy && \
		    ${PY2VERS} ./setup.py     install --prefix=$(TOP)/debian/tmpp  ;\
		    ${PY2VERS} ./setup_mpi.py install --prefix=$(TOP)/debian/tmpp)
	for p in $(PY3VERS) ; do \
		( cd wrappers/numpy && \
		    $$p ./setup3.py     install --prefix=$(TOP)/debian/tmpp   ;\
		    $$p ./setup3_mpi.py install --prefix=$(TOP)/debian/tmpp ) ;\
	done
	# Clean up.
	rm -r debian/tmp/*
	# Now do the static build we want.
	dh_auto_build

override_dh_auto_install:
	find . -name .gitignore -delete
	$(MAKE) install DESTDIR=$(DESTDIR)
	install -D -m 644  adios.pc $(TOP)/debian/tmp/$(LIBDIR)/pkgconfig/adios.pc
	# Sort python stuff
	mkdir -p $(TOP)/debian/tmp/usr/lib/python3/dist-packages
	mkdir -p $(TOP)/debian/tmp/usr/lib/${PY2VERS}/dist-packages
	for p in $(PY3VERS); do \
		v=`echo $$p | cut -c7,9` ;\
		CYV=cpython-$${v}m ;\
		CYVM=cpython-$${v}m-${DEB_HOST_MULTIARCH} ;\
		if [ $$p = python3.5 ]; then \
			CYV=$$CYVM ;\
		fi;\
		mv $(TOP)/debian/tmpp/lib/$${p}/site-packages/adios3.$${CYV}.so \
			debian/tmp/usr/lib/python3/dist-packages/adios.$${CYVM}.so  ; \
		mv $(TOP)/debian/tmpp/lib/$${p}/site-packages/adios3_mpi.$${CYV}.so \
			debian/tmp/usr/lib/python3/dist-packages/adios_mpi.$${CYVM}.so  ; \
	done
	mv $(TOP)/debian/tmpp/lib/${PY2VERS}/site-packages/adios_mpi.so \
		debian/tmp/usr/lib/${PY2VERS}/dist-packages/adios_mpi.${DEB_HOST_MULTIARCH}.so
	mv $(TOP)/debian/tmpp/lib/${PY2VERS}/site-packages/adios.so \
		debian/tmp/usr/lib/${PY2VERS}/dist-packages/adios.${DEB_HOST_MULTIARCH}.so
	rm -r debian/tmpp
	# remove due to it not working in multi-arch;
	rm -f  $(BINDIR)/adios_config.flags
	# renamed as per Adios CCS issue #118716, Debbug #639257
	mv $(BINDIR)/gpp.py $(BINDIR)/adiosxml2h
	mv $(BINDIR)/ad_config.py $(BINDIR)/ad_config
	mv $(BINDIR)/skel_cat.py $(BINDIR)/skel_cat
	mv $(BINDIR)/skel_extract.py $(BINDIR)/skel_extract
	cp debian/adios_config $(BINDIR)/adios_config
	# mv $(DESTDIR)/bin/xmlparser.py $(DESTDIR)/bin/xmlparser

override_dh_auto_test:
	$(DO_TEST) && $(MAKE) check || echo "Tests disabled on bigendian systems for the moment"

override_dh_installexamples:
	dh_installexamples
	find debian/libadios-dev/usr/share/doc/libadios-dev/examples -name '*.o' -delete 
	find debian/libadios-dev/usr/share/doc/libadios-dev/examples/C -type f -exec chmod -x {} \;

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/libadios-bin/etc/adios/skel/templates/*.tpl
	chmod -x debian/libadios-bin/etc/adios/skel/templates/*.tmpl
